<template>
    <div class="list-view">
        <div class="filters-container">
            <!-- <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button> -->
            <!-- <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">创建申请 </el-button> -->
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
            <el-table-column prop="organizer" label="承办单位"> </el-table-column>
            <el-table-column prop="createdAt" label="申请时间"></el-table-column>
            <el-table-column prop="year" label="年度"> </el-table-column>
            <el-table-column prop="status" label="状态" :formatter="statusFormatter"> </el-table-column>
            <!-- <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button
                        v-if="row.status === 'FIRST_REVIEW_PASS'"
                        :loading="row.loading"
                        @click="open(row)"
                        type="success"
                        size="mini"
                        plain
                    >
                        通过
                    </el-button>
                    <el-button
                        v-if="row.status === 'FIRST_REVIEW_PASS'"
                        :loading="row.loading"
                        @click="audit(row, 'EXPERT_PASS')"
                        type="warning"
                        size="mini"
                        plain
                    >
                        拒绝
                    </el-button>
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看附件</el-button>
                </template>
            </el-table-column> -->
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import rateStatus from '@/mixins/rateStatus';

export default {
    name: 'RateList',
    mixins: [pageableTable, rateStatus],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/rate/all2',
            downloading: false
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        },
        ...mapState(['userInfo'])
    },
    methods: {
        beforeGetData() {
            return {
                sort: 'createdAt,desc',
                search: this.search,
                query: {
                    expertUserId: this.userInfo.id,
                    status: ['FIRST_REVIEW_PASS', 'EXPERT_PASS', 'EXPERT_DENY'],
                    submit: true
                }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/rateEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/organization',
                query: {
                    organId: row.organizationId,
                    rateId: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/rate/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/rate/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        audit(row, status) {
            this.$set(row, 'loading', true);
            this.$http
                .post('/rate/audit', {
                    id: row.id,
                    status: status,
                    score: 0
                })
                .then(res => {
                    this.$set(row, 'loading', false);
                    this.$message.success('OK');
                    this.getData();
                })
                .catch(e => {
                    console.log(e);
                    this.$set(row, 'loading', false);
                    this.$message.error(e.error);
                });
        },
        open(row) {
            this.$set(row, 'loading', true);
            this.$prompt('请输入分数', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消'
            })
                .then(({ value }) => {
                    this.$message({
                        type: 'success',
                        message: '分数是: ' + value
                    });
                    this.$http
                        .post('/rate/audit', {
                            id: row.id,
                            status: 'EXPERT_PASS',
                            score: value
                        })
                        .then(res => {
                            this.$set(row, 'loading', false);
                            this.$message.success('OK');
                            this.getData();
                        })
                        .catch(e => {
                            console.log(e);
                            this.$set(row, 'loading', false);
                            this.$message.error(e.error);
                        });
                })
                .catch(() => {
                    this.$message({
                        type: 'info',
                        message: '取消输入'
                    });
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
